function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { PrimaryColumn, Entity, Index, JoinColumn, Column, ManyToOne } from "typeorm";
import { User } from "./user.js";
import { UserGroup } from "./user-group.js";
import { id } from "../id.js";
export let Muting = class Muting {
    id;
    createdAt;
    expiresAt;
    muteeId;
    mutee;
    groupId;
    group;
    muterId;
    muter;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Muting.prototype, "id", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        comment: "The created date of the Muting."
    }),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Muting.prototype, "createdAt", void 0);
_ts_decorate([
    Index(),
    Column("timestamp with time zone", {
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Muting.prototype, "expiresAt", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The mutee user ID."
    }),
    _ts_metadata("design:type", Object)
], Muting.prototype, "muteeId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Muting.prototype, "mutee", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Muting.prototype, "groupId", void 0);
_ts_decorate([
    ManyToOne((type)=>UserGroup, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Muting.prototype, "group", void 0);
_ts_decorate([
    Index(),
    Column({
        ...id(),
        comment: "The muter user ID."
    }),
    _ts_metadata("design:type", Object)
], Muting.prototype, "muterId", void 0);
_ts_decorate([
    ManyToOne((type)=>User, {
        onDelete: "CASCADE"
    }),
    JoinColumn(),
    _ts_metadata("design:type", Object)
], Muting.prototype, "muter", void 0);
Muting = _ts_decorate([
    Entity(),
    Index([
        "muterId",
        "muteeId"
    ], {
        unique: true,
        where: '"groupId" IS NULL'
    }),
    Index([
        "groupId",
        "muteeId"
    ], {
        unique: true,
        where: '"groupId" IS NOT NULL'
    })
], Muting);
